<?php

class FbTopsMain {

  public $top_name;
  public $top_categories;
  public $top_pagination;
  public $top_pagination_type;
  public $top_update;
  public $top_id;

  public function __construct() {
    $array_of_options = array('fbtops_name', 'fbtops_categories', 'fbtops_pagination', 'fbtops_pagination_style');
    //make a fictional top id... will be used to let user make more tops in a later version
    $this->top_id = 1;
    //get options from top
    $this->top_categories = get_option('fbtops_categories');
    $this->top_name = get_option('fbtops_name');
    $this->top_pagination = get_option('fbtops_pagination');
    $this->top_pagination_type = get_option('fbtops_pagination_style');
  }

  public function checkIfTop() {

    if (!get_option('fbtops_name'))
      return FALSE;
    else
      return $this->get_top();
  }

  public function get_top() {
    $top = array();
    $top['name'] = get_option('fbtops_name');
    $top['categories'] = unserialize(get_option('fbtops_categories'));
    $top['pagination'] = get_option('fbtops_pagination');
    $top['pagination_style'] = get_option('fbtops_pagination_style');

    return $top;
  }

  public function set_top() {
    $array_of_options = array('fbtops_name', 'fbtops_categories', 'fbtops_pagination', 'fbtops_pagination_style');
    //check if we have a top name
    if (!get_option('fbtops_name')) {
      //remove old values if they exist
      for ($i = 1; $i <= 3; $i++) {
        $option = get_option($array_of_options[$i]);
        if (!$option)
          $empty = delete_option($array_of_options[$i]);
      }
      //We have a clean options table. We can set now the values
      add_option('fbtops_name', $this->top_name);
      add_option('fbtops_categories', serialize($this->top_categories));
      add_option('fbtops_pagination', $this->top_pagination);
      add_option('fbtops_pagination_style', $this->top_pagination_type);
    }
    else {
      //update top
      update_option('fbtops_name', $this->top_name);
      update_option('fbtops_categories', serialize($this->top_categories));
      update_option('fbtops_pagination', $this->top_pagination);
      update_option('fbtops_pagination_style', $this->top_pagination_type);
    }

    $set_top_posts = $this->set_top_posts();
    $top = $this->get_top();
    return $top;
  }

  public function set_top_posts() {
    //cleanup database. More clear procedure in the future
    $this->delete_top_posts();
    return $this->insert_post_ids_into_top_database();
  }

  private function delete_top_posts() {

    global $wpdb, $table_tops_posts;
    //WARNING we delete all records from fbtops_posts table!!!!
    $delete_records = $wpdb->query("TRUNCATE TABLE " . $table_tops_posts);
    return $delete_records;
  }

  private function insert_post_ids_into_top_database() {
    global $wpdb, $table_tops_posts;
    $post_ids = array();
    $categories_top = $this->top_categories;
//get maximum posts to have for inserting the posts
    $max_number = $this->get_max_cat_posts_number($categories_top);
    if ($max_number > 200)
      $max_number = 200;
    foreach ($categories_top as $categoryy) {
      $posts = get_posts(array('numberposts' => $max_number, 'category__in' => array($categoryy)));
      if ($posts) {
        foreach ($posts as $post) {
          //$post_ids[$post->ID]['ioio'] = $post;
          $post_ids[$post->ID]['permalink'] = get_permalink($post->ID);
          $comments_number = wp_count_comments($post->ID);
          $post_ids[$post->ID]['comments_wp'] = $comments_number->total_comments;
          $permalinks[$post->ID] = $post_ids[$post->ID]['permalink'];
        }
      }
    }
    //split array to get more result at once from FB
    $split_array = array_chunk($permalinks, 50, true);
    
    foreach ($split_array as $splited_array) {
      $string = '"' . implode('","', $splited_array) . '"';
      //get data from facebook
      $query = 'SELECT share_count, like_count, comment_count, total_count, url FROM link_stat WHERE url IN (' . $string . ')';
      $call = "https://graph.facebook.com/fql?q=" . rawurlencode($query);
      $output = file_get_contents($call);
      $facebook_data = reset(json_decode($output));
      foreach ($facebook_data as $fb_post_data) {
        $id = array_search($fb_post_data->url, $splited_array);
        $comments_wp = $post_ids[$id]['comments_wp'];
        $comments_total = $fb_post_data->comment_count + $post_ids[$id]['comments_wp'];
        $sql = $wpdb->insert($table_tops_posts, array('post_id' => $id,
          'top_id' => 1,
          'facebook_likes' => $fb_post_data->total_count,
          'facebook_shares' => $fb_post_data->share_count,
          'comments' => $comments_total
            )
        );
      }
    }
  }

  public function get_max_cat_posts_number($categories_array = array()) {
    $cats = implode(',', $categories_array);
    //find how many posts per category
    $cat_number = array();
    $categs = get_categories('include=' . $cats);
    foreach ($categs as $categ) {
      $cat_number[] = $categ->count;
    }
    return max($cat_number);
  }

  public function delete_top() {
    $array_of_options = array('fbtops_name', 'fbtops_categories', 'fbtops_pagination', 'fbtops_pagination_style');
    foreach ($array_of_options as $option) {
      delete_option($option);
    }
    $delete_posts = $this->delete_top_posts();
    echo 'The top was deleted';
  }

  public function make_pagination() {
    global $wpdb, $table_tops_posts;
    $pagination = array();
    $newp = $_GET['toppage'];
    $plimit = $this->top_pagination_type;
    $strSQL = mysql_query("SELECT * FROM `" . $table_tops_posts . "` WHERE  `top_id` = " . $this->top_id);
    $totalrows = mysql_num_rows($strSQL);
    $pnums = ceil($totalrows / $plimit);
    if ($newp == '') {
      $newp = '1';
    }
    $start = ($newp - 1) * $plimit;
    $starting_no = $start + 1;
    if ($totalrows - $start < $plimit) {
      $end_count = $totalrows;
    }
    elseif ($totalrows - $start >= $plimit) {
      $end_count = $start + $plimit;
    }
//put all variables in $pagination array
    $pagination['newp'] = $newp;
    $pagination['plimit'] = $plimit;
    $pagination['pnums'] = $pnums;
    $pagination['start'] = $start;
    $pagination['end_count'] = $end_count;
    return $pagination;
  }

  function display_table_rows($sort) {

    $table_rows = $this->get_table_rows($sort, $limit);
    $rows = '';
    foreach ($table_rows as $key => $table_row) {
      $rank = $key + 1;
      if ($_GET['toppage']) {
        $numberone = $_GET['toppage'] - 1;
        $numbertwo = $numberone * $this->top_pagination_type;
        $rank = $numbertwo + $key + 1;
      }
      $oddoreven = 'even';
      $permalink = get_permalink($table_row->post_id);
      if ($key % 2 == 0)
        $oddoreven = 'odd';

      $rows .= '<tr class="' . $oddoreven . '">';
      $rows .= '<td>' . $rank . '</td>';
      $rows .= '<td>' . $table_row->facebook_likes . '</td>';
      $rows .= '<td>' . $table_row->facebook_shares . '</td>';
      $rows .= '<td>' . $table_row->comments . '</td>';
      $rows .= '<td class="post-titles"><a href="' . $permalink . '">' . get_the_title($table_row->post_id) . '</td>';
      $rows .= '</tr>';
    }

    return $rows;
  }

  function get_table_rows($sort = 'facebook_likes DESC') {
    $pagination = $this->make_pagination();
    $limit = '';
    if ($this->top_pagination == 1) {
      $limit = ' LIMIT ' . $pagination['start'] . ', ' . $this->top_pagination_type;
    }

    global $wpdb, $table_tops_posts;
    $sql = "SELECT * FROM " . $table_tops_posts . " ORDER BY " . $sort . $limit;
    $rows = $wpdb->get_results($sql);
    return $rows;
  }

  function cron_update_top() {
    //check if top 
    $top_api = new FbTopsMain();
    $is_top = $top_api->checkIfTop();
    // if there is a top we make updates to posts data. 
    if ($is_top) {
      //clear 
      $top_api->top_categories = unserialize(get_option('fbtops_categories'));

      //$top_api->set_top_posts();
    }
  }

}

?>
