<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class FBTopsSetup {

  /**
   * construct function for later use
   */
  public function __construct() {
    
  }

  function admin_menu_add_top() {
    $icon_url = plugins_url('fbtops/media/images/fbtops-icon.png');
    $hookname = add_menu_page(__('FBtops', 'fbtops'), __('FBtops', 'fbtops'), 'manage_options', 'fbtops_addtop', array('FBTopsSetup', 'admin_add_top'),$icon_url);
  }

  public function admin_add_top() {
    // No access for you if you can't manage_options
    if (!current_user_can('manage_options')) {
      wp_die(__('You do not have sufficient permissions to access this page.'), 'fbtops');
    }
    require WP_PLUGIN_DIR . '/fbtops/views/admin/add_top.php';
  }

  function fbtops_print_javascript($hook) {
    if ($hook == 'toplevel_page_fbtops_addtop') {
      $link = plugins_url('fbtops/media/js/fbtops.js');
      wp_enqueue_script('fbtops', $link, array('jquery'));
    }
  }

  function fbtops_get_ajax_category() {
    require WP_PLUGIN_DIR . '/fbtops/views/admin/fbtops_process_ajax.php';
    die();
  }

  function add_admin_css_style() {
    wp_register_style('fbtops_admin_css', WP_PLUGIN_URL . '/fbtops/media/css/fbtops_admin.css', false, '1.0.0');
    wp_enqueue_style('fbtops_admin_css');
  }

  function add_frontend_style() {
    wp_register_style('fbtops_frontend_css', WP_PLUGIN_URL . '/fbtops/media/css/fbtops_frontend.css', false, '1.0.0');
    wp_enqueue_style('fbtops_frontend_css');
  }

  function update_top_schedule() {
    wp_schedule_event(time(), 'hourly', 'fbtops_hourly_event_hook');
   
  }

  function fbposts_deactivation() {
    wp_clear_scheduled_hook('fbtops_hourly_event_hook');
  }

  function install_mysql() {
    global $wpdb, $fbtops_version, $table_tops_posts;

    $sql_create_tops_posts_table = "CREATE TABLE $table_tops_posts (
                    id mediumint(9) NOT NULL AUTO_INCREMENT,
                    post_id bigint(20) NOT NULL,
                    top_id bigint(20) NOT NULL,
                    facebook_likes int (11),
                    facebook_shares int (11),
                    comments bigint(20),
                    UNIQUE KEY id (id)
                );";
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql_create_tops_posts_table);
    add_option("fbtops_version", $fbtops_version);
  }

}
