<?php
/*
Plugin Name: FB Tops
Plugin URI: http://fbtops.kuantero.com/
Description: Sponsored by Kuantero
Version: 1.1
Author: Kuantero
Author URI: http://kuantero.com
License: GPL2
 * 
Copyright 2013  Mihai Ghita  (email : mihai.ghita@pro-drupal.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as 
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

//Set globals
global $wpdb;
global $fbtops_version;
global $table_tops_posts;

//Set version
$fbtops_version = '1.0';

//Set Database table
$table_tops_posts = $wpdb->prefix . 'fbtops_posts';

//classes
require WP_PLUGIN_DIR.'/fbtops/classes/admin/fbtops_setup.php';
require WP_PLUGIN_DIR.'/fbtops/classes/admin/fbtops_main.php';
require WP_PLUGIN_DIR.'/fbtops/classes/frontend/fbtops_frontend.php';

load_plugin_textdomain('fbtops', false, dirname(plugin_basename(__FILE__) . '/languages/'));

//various hooks and actions
register_activation_hook(__FILE__ , array('FBTopsSetup' , 'install_mysql'));
add_action('admin_enqueue_scripts', array('FBTopsSetup' , 'fbtops_print_javascript'));
add_action('admin_menu', array('FBTopsSetup' , 'admin_menu_add_top'));
add_shortcode( 'fbtops', array('FbTopsFrontend', 'shortcode_display'));
add_action('wp_ajax_fbgetcategory_top', array('FBTopsSetup' , 'fbtops_get_ajax_category'));
add_action( 'admin_enqueue_scripts', array('FBTopsSetup' , 'add_admin_css_style'));
add_action( 'wp_enqueue_scripts', array('FBTopsSetup' , 'add_frontend_style'));
add_action('fbtops_hourly_event_hook', array('FbTopsMain', 'cron_update_top'));
 
register_activation_hook( __FILE__,  array('FBTopsSetup' , 'update_top_schedule'));
register_deactivation_hook( __FILE__, array('FBTopsSetup' ,'fbposts_deactivation'));